//-----------------------------------------------------------------------------
// Path:  SDK\DEMOS\Direct3D9\src\PracticalCubeShadowMaps
// File:  LookUpTables.h
// 
// Copyright NVIDIA Corporation 2004
// TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED
// *AS IS* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS
// OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY
// AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL NVIDIA OR ITS SUPPLIERS
// BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES
// WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS,
// BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS)
// ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS
// BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
//-----------------------------------------------------------------------------


#ifndef __LUT_H_included_
#define __LUT_H_included_

const int halfSpaceRemap[64] = { 
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	-1, -1, -1, -1, -1,  0,  1,  2, -1,  3,  4,  5, -1,  6,  7,  8,
	-1, -1, -1, -1, -1,  9, 10, 11, -1, 12, 13, 14, -1, 15, 16, 17,
	-1, -1, -1, -1, -1, 18, 19, 20, -1, 21, 22, 23, -1, 24, 25, -1
};

//  lookup table that stores which edges will be extruded for a given half-space configuration.
const DWORD silhouettes[26][6][2] = {
    { { MIN_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z }, { MAX_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z } },
	{ { MIN_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z }, { MAX_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z } },
	{ { MIN_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z }, { MAX_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z } },
	{ { MAX_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MIN_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MAX_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z } },
	{ { MAX_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MIN_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z } },
	{ { MAX_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MIN_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MAX_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z } },
	{ { MAX_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MAX_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z } },
	{ { MAX_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z } },
	{ { MAX_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z }, { INVALID, INVALID }, { INVALID, INVALID } },
	{ { MIN_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z }, { MAX_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z } },
	{ { MIN_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z }, { MAX_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z } },
	{ { MIN_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z }, { MAX_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MAX_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z } },
	{ { MAX_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MAX_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z } },
	{ { MAX_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z } },
	{ { MAX_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MAX_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z } },
	{ { MIN_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MAX_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z } },
	{ { MIN_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z } },
	{ { MIN_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z }, { INVALID, INVALID }, { INVALID, INVALID } },
	{ { MIN_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MAX_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z } },
	{ { MIN_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z } },
	{ { MIN_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MAX_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MAX_Y|MAX_Z }, { INVALID, INVALID }, { INVALID, INVALID } },
	{ { MAX_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MAX_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z } },
	{ { MAX_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z } },
	{ { MAX_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MIN_Z }, { MIN_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MIN_Y|MAX_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MIN_Y|MIN_Z }, { INVALID, INVALID }, { INVALID, INVALID } },
	{ { MAX_X|MIN_Y|MIN_Z, MAX_X|MIN_Y|MAX_Z }, { MAX_X|MAX_Y|MAX_Z, MAX_X|MAX_Y|MIN_Z }, { MAX_X|MAX_Y|MIN_Z, MAX_X|MIN_Y|MIN_Z }, { MAX_X|MIN_Y|MAX_Z, MAX_X|MAX_Y|MAX_Z }, { INVALID, INVALID }, { INVALID, INVALID } },
	{ { MIN_X|MIN_Y|MAX_Z, MIN_X|MIN_Y|MIN_Z }, { MIN_X|MAX_Y|MIN_Z, MIN_X|MAX_Y|MAX_Z }, { MIN_X|MIN_Y|MIN_Z, MIN_X|MAX_Y|MIN_Z }, { MIN_X|MAX_Y|MAX_Z, MIN_X|MIN_Y|MAX_Z }, { INVALID, INVALID }, { INVALID, INVALID } }
};

#endif